/*
 * CryptInputStream.java
 */

package rpcs.io;

import java.io.InputStream;
import java.io.FilterInputStream;
import java.io.IOException;

public class CryptInputStream extends InputStream {
    protected InputStream in;
    protected String Cypher;
    protected byte[] bCypher;
    protected int CypherPos;
    protected int CypherLen;

    public CryptInputStream(InputStream in) {
	this.in = in;
	this.Cypher = new String("Z#$()aBc@-LkdGhq948GhdjWBddSEH");
	this.CypherLen = this.Cypher.length();
	this.bCypher = new byte[this.CypherLen];
	this.bCypher = this.Cypher.getBytes();
	this.CypherPos = -1;
    }

    public CryptInputStream(InputStream in, String cypher) {
	this.in = in;
	this.Cypher = new String(cypher);
	this.CypherLen = this.Cypher.length();
	this.bCypher = new byte[this.CypherLen];
	this.bCypher = this.Cypher.getBytes();
	this.CypherPos = -1;
    }

    public int read() throws IOException {
	this.CypherPos++;
	if (CypherPos > CypherLen)
	   CypherPos = 0;
	int rd = in.read();
	return (int ) (bCypher[CypherPos] ^ rd);
    }

    public int read(byte b[]) throws IOException {
	return read(b, 0, b.length);
    }

    public int read(byte b[], int off, int len) throws IOException {
	int rd = in.read(b, off, len);
	for (int i=0; i<=rd; i++) {
	   this.CypherPos++;
	   if (CypherPos > CypherLen)
	      CypherPos = 0;
	   b[i] = (byte ) ((b[i] ^ bCypher[CypherPos]));
	}

	return rd;
    }

    public long skip(long n) throws IOException {
	return in.skip(n);
    }

    public int available() throws IOException {
	return in.available();
    }

    public void close() throws IOException {
	in.close();
    }

    public synchronized void mark(int readlimit) {
	in.mark(readlimit);
    }

    public synchronized void reset() throws IOException {
	in.reset();
    }

    public boolean markSupported() {
	return in.markSupported();
    }
}
