
/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

package rpcs.system;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import rpcs.system.*;
import rpcs.event.*;
import cware.awt.layouts.*;

public class RPCSForm {
	JPanel mPanel;		/* Main Panel */
	JPanel bPanel;		/* Button Panel */
	JPanel fPanel;		/* Form Panel */
	JLabel jLabel;
	JTextField jTextField;
	JCheckBox jCheckBox;
	JComboBox jComboBox;
	public Vector vField;
	public Vector vLabel;
	public Vector vTitle;
	JButton[] tButton;
	JComponent Lcomp;
	JComponent Ccomp;
	JComponent Xcomp;
	JComponent Ycomp;
	String Svalue;
	int tmp;
	int Algn;
	int Spacing=10;

	Vector FormListeners = new Vector();

	public RPCSForm() {
		mPanel = new JPanel();
		init(true);
	}

	public RPCSForm(JPanel panel) {
		mPanel = panel;
		init(true);
	}

	public RPCSForm(JPanel panel, boolean buttons) {
		mPanel = panel;
		init(buttons);
	}

	public void init(boolean addbutton) {
		
		if (addbutton) {
		   fPanel = new JPanel();
		   mPanel.setLayout(new BorderLayout());
		   mPanel.add(fPanel, "Center");

   		   bPanel = new JPanel();
   		   bPanel.setBackground(Color.white);
   		   mPanel.add(bPanel, "South");
   
   		   tButton = new JButton[3];
   		   tButton[0] = new JButton("  OK  ");
   		   tButton[1] = new JButton("  Cancel  ");
   		   tButton[2] = new JButton("  Reset  ");
   		   bPanel.add(tButton[0], "East");
   		   bPanel.add(tButton[1], "Center");
   		   bPanel.add(tButton[2], "West");
   		   tButton[0].addActionListener(new ActionListener() {
   			public void actionPerformed(ActionEvent e) {
			   for (int i=0; i<FormListeners.size(); i++) {
			      FormListener fl = (FormListener) 
				FormListeners.elementAt(i);
			      fl.okClicked();
			   }
   			}
   		   });
   		   tButton[1].addActionListener(new ActionListener() {
   			public void actionPerformed(ActionEvent e) {
			   for (int i=0; i<FormListeners.size(); i++) {
			      FormListener fl = (FormListener) 
				FormListeners.elementAt(i);
			      fl.cancelClicked();
			   }
   			}
   		   });
   		   tButton[2].addActionListener(new ActionListener() {
   			public void actionPerformed(ActionEvent e) {
			   for (int i=0; i<FormListeners.size(); i++) {
			      FormListener fl = (FormListener) 
				FormListeners.elementAt(i);
			      fl.resetClicked();
			   }
   			}
   		   });
		}
		else	// TAG - does it need this ?????
		   fPanel = mPanel;

		fPanel.setLayout(new AlignLayout());

		vField = new Vector();
		vLabel = new Vector();
		vTitle = new Vector();
		Lcomp = new JLabel();
   		fPanel.add(Lcomp, new AlignConstraint(80,10));
		Algn = AlignConstraint.RIGHTBELOW;
	}

	public void add(String title, int value, int len) {
		Svalue = String.valueOf(value);
		add(title, Svalue, len);
	}

	public void add(String title, float value, int len) {
		Svalue = String.valueOf(value);
		add(title, Svalue, len);
	}

	public void add(String title, int value) {
		Svalue = String.valueOf(value);
		add(title, Svalue, 3);
	}

	public void add(String title, float value) {
		Svalue = String.valueOf(value);
		add(title, Svalue, 3);
	}

	public void add(String title, boolean value) {
		jCheckBox = new JCheckBox("", value);
		add(title, jCheckBox);
	}

	public void add(String title, String[] list, String value) {
		jComboBox = new JComboBox();
		jComboBox.setEditable(false);
		for (int i=0; i<list.length; i++)
		  jComboBox.addItem(list[i]);
		jComboBox.setSelectedItem(value);
		add(title, jComboBox);
	}

	public void add(String title, String value) {
		add(title, value, 7);
	}

	public void add(String title, String value, int len) {
		jTextField = new JTextField(value);
		jTextField.setColumns(len+1);
		add(title, jTextField);
	}

	public void add(String title, JComponent comp) {
		jLabel = new JLabel(title);
		vLabel.addElement(jLabel);
		vTitle.addElement(title);
		vField.addElement(comp);
		fPanel.add(jLabel, new AlignConstraint(Lcomp, Algn, Spacing));
/*
		if (Algn == AlignConstraint.RIGHTBELOW) {
		   tmp = vLabel.indexOf(Lcomp);
		   Ccomp = null;
		   if (tmp != -1)
		      Ccomp = (JComponent )vField.elementAt(tmp);
		   if (Ccomp != null) {
		      fPanel.add(comp, new AlignConstraint(Ccomp, 
				     AlignConstraint.LEFTBELOW, 10));
		   }
		   else
		      fPanel.add(comp, new AlignConstraint(jLabel, 
				          AlignConstraint.TOPRIGHT, 10));
		} else {
		   fPanel.add(comp, new AlignConstraint(jLabel, 
				          AlignConstraint.TOPRIGHT, 10));
		}
*/
		fPanel.add(comp, new AlignConstraint(jLabel, 
				          AlignConstraint.TOPRIGHT, 10));
		Lcomp = jLabel;
		Algn = AlignConstraint.RIGHTBELOW;
		Spacing=10;
	}

	public int getIntFieldValue(String label) {
		try {
		  return (Integer.parseInt(getFieldValue(label)) + 0);
		} catch (Exception e) { return 0; }
	}

	public float getFloatFieldValue(String label) {
		Float flt = new Float(getFieldValue(label));
		return (flt.floatValue() + (float )0.0);
	}

	public boolean getBooleanFieldValue(String label) {
		if (getFieldValue(label).equals("true"))
		  return true;
		else
		  return false;
	}

	public String getFieldValue(String label) {
		int x = vTitle.indexOf(label);
		if (x == -1) {
		   System.out.println("Unable to getValue: " + label);
		   return "";
		}

		JComponent c = (JComponent )vField.elementAt(x);
		if (c instanceof JTextField) {
			jTextField = (JTextField ) c;
			return jTextField.getText();
		}
		else if (c instanceof JComboBox) {
			jComboBox = (JComboBox ) c;
			return (String )jComboBox.getSelectedItem();
		}
		else if (c instanceof JCheckBox) {
			jCheckBox = (JCheckBox ) c;
			if (jCheckBox.isSelected())
				return "true";
			else
				return "false";
		}
		return "";
	}

	public void newColumn(String title) {
   		int x = vTitle.indexOf(title);
		if (x == -1) {
		   System.out.println("Unable to newColumn: " + title);
		   return;
		}
		Lcomp = (JComponent )vField.elementAt(x);
		Algn = AlignConstraint.TOPRIGHT;
	}

	public void newRow(String title) {
   		int x = vTitle.indexOf(title);
		if (x == -1) {
		   System.out.println("Unable to newRow: " + title);
		   return;
		}
		Lcomp = (JComponent )vLabel.elementAt(x);
		Algn = AlignConstraint.RIGHTBELOW;
	}

	public void newBlankRow(String title) {
   		int x = vTitle.indexOf(title);
		if (x == -1) {
		   System.out.println("Unable to newBlankRow: " + title);
		   return;
		}
		Lcomp = (JComponent )vLabel.elementAt(x);
		Algn = AlignConstraint.RIGHTBELOW;
		Spacing=15;
	}

	public void newColumnRow(String XLabel, String YLabel, String title, String value) {
		newColumnRow(XLabel, YLabel, title, value, 7);
	}

	public void newColumnRow(String XLabel, String YLabel, String title, int value) {
		Svalue = String.valueOf(value);
		newColumnRow(XLabel, YLabel, title, Svalue, 3);
	}

	public void newColumnRow(String XLabel, String YLabel, String title, String value, int len) {
		jTextField = new JTextField(value);
		jTextField.setColumns(len+1);
		newColumnRow(XLabel, YLabel, title, jTextField);
	}

	public void newColumnRow(String XLabel, String YLabel, String title, String[] list, String value) {
		jComboBox = new JComboBox();
		jComboBox.setEditable(false);
		for (int i=0; i<list.length; i++)
		  jComboBox.addItem(list[i]);
		jComboBox.setSelectedItem(value);
		newColumnRow(XLabel, YLabel, title, jComboBox);
	}

	public void newColumnRow(String XLabel, String YLabel, String title, float value) {
		Svalue = String.valueOf(value);
		newColumnRow(XLabel, YLabel, title, Svalue, 3);
	}

	public void newColumnRow(String XLabel, String YLabel, String title, boolean value) {
		jCheckBox = new JCheckBox("", value);
		newColumnRow(XLabel, YLabel, title, jCheckBox);
	}

	public void newColumnRow(String XLabel, String YLabel, String title, JComponent comp) {
		int x = vTitle.indexOf(XLabel);
		int y = vTitle.indexOf(YLabel);
		if (x == -1 || y == -1) {
			System.out.println("Unable to XY Align: " + title + " with: " + XLabel + ", " + YLabel);
			add(title, comp);
			return;
		}
		Xcomp = (JComponent )vLabel.elementAt(x);
		Ycomp = (JComponent )vLabel.elementAt(y);

		jLabel = new JLabel(title);
		vLabel.addElement(jLabel);
		vTitle.addElement(title);
		vField.addElement(comp);

		fPanel.add(jLabel, new AlignConstraint(Xcomp, AlignConstraint.RIGHTBELOW, Spacing,
					Ycomp, AlignConstraint.TOPRIGHT, Spacing));
		fPanel.add(comp, new AlignConstraint(jLabel, AlignConstraint.TOPRIGHT, 10));
		Lcomp = jLabel;
		Algn = AlignConstraint.RIGHTBELOW;
		Spacing=10;
	}

	public void replace(String title, JComponent Tcomp) {
		int x = vTitle.indexOf(title);
		if (x == -1) {
		   System.out.println("Unable to replace: " + title);
		   return;
		}
		vField.setElementAt(Tcomp, x);
	}

	public void setValue(String title, String value) {
		int x = vTitle.indexOf(title);
		if (x == -1) {
		   System.out.println("Unable to setValue: " + title);
		   return;
		}

		JComponent c = (JComponent )vField.elementAt(x);
		if (c instanceof JTextField) {
// System.out.println("Setting: TF = " + value);
			jTextField = (JTextField ) c;
			jTextField.setText(value);
		}
		else if (c instanceof JComboBox) {
// System.out.println("Setting: CBx = " + value);
			jComboBox = (JComboBox ) c;
			jComboBox.setSelectedItem(value);
		}
		else if (c instanceof JCheckBox) {
// System.out.println("Setting: CkB = " + value);
			jCheckBox = (JCheckBox ) c;
			if (value.equals("true"))
			   jCheckBox.setSelected(true);
			else
			   jCheckBox.setSelected(false);
		}
		return;
	}

	public void replace(String title, String[] list, String value) {
		int x = vTitle.indexOf(title);
		if (x == -1) {
		   System.out.println("Unable to replace: " + title);
		   return;
		}
		jComboBox = (JComboBox )vField.elementAt(x);
		jComboBox.setEditable(false);
		jComboBox.removeAllItems();
		for (int i=0; i<list.length; i++)
		  jComboBox.addItem(list[i]);
		jComboBox.setSelectedItem(value);
//		replace(title, jComboBox);
	}

	public void setValue(String title, int value) {
		Svalue = String.valueOf(value);
		setValue(title, Svalue);
	}

	public void setValue(String title, float value) {
		Svalue = String.valueOf(value);
		setValue(title, Svalue);
	}

	public void setValue(String title, boolean value) {
		if (value)
		   setValue(title, "true");
		else
		   setValue(title, "false");
	}

	public void remove(String title) {
		int x = vTitle.indexOf(title);
		if (x == -1) {
		   System.out.println("Unable to remove: " + title);
		   return;
		}
		vTitle.removeElementAt(x);
		fPanel.remove((JComponent )vField.elementAt(x));
		fPanel.remove((JComponent )vLabel.elementAt(x));
		vLabel.removeElementAt(x);
		vField.removeElementAt(x);
	}

	public synchronized void addFormListener(FormListener fl) {
		FormListeners.addElement(fl);
	}

	public synchronized void removeFormListener(FormListener fl) {
		FormListeners.removeElement(fl);
	}
}
